Skip site navigation (1)Skip section navigation (2)
Date:      Sun, 17 Jan 2016 12:07:57 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-user@freebsd.org
Subject:   svn commit: r294211 - user/pho/stress2/misc
Message-ID:  <201601171207.u0HC7vgZ077840@repo.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Sun Jan 17 12:07:57 2016
New Revision: 294211
URL: https://svnweb.freebsd.org/changeset/base/294211

Log:
  Added two regression tests.
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/advlock.sh   (contents, props changed)
  user/pho/stress2/misc/dev2.sh   (contents, props changed)

Added: user/pho/stress2/misc/advlock.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/advlock.sh	Sun Jan 17 12:07:57 2016	(r294211)
@@ -0,0 +1,246 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2016 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+
+# From r238952's commit log:
+# The first change closes a race where an open() that will block with O_SHLOCK
+# or O_EXLOCK can increase the write count while it waits.  If the process
+# holding the current lock on the file then tries to call exec() on the file
+# it has locked, it can fail with ETXTBUSY even though the advisory lock is
+# preventing other threads from successfully completing a writable open().
+#
+# The second change closes a race where a read-only open() with O_SHLOCK or
+# O_EXLOCK may return successfully while the write count is non-zero due to
+# another descriptor that had the advisory lock and was blocking the open()
+# still being in the process of closing.  If the process that completed the
+# open() then attempts to call exec() on the file it locked, it can fail with
+# ETXTBUSY even though the other process that held a write lock has closed
+# the file and released the lock.
+
+# https://people.freebsd.org/~pho/stress/log/kostik859.txt
+# https://people.freebsd.org/~pho/stress/log/kostik860.txt
+
+# Fixed by r294204.
+
+. ../default.cfg
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/advlock.c
+mycc -o advlock -Wall -Wextra -O0 -g advlock.c || exit 1
+rm -f advlock.c
+
+mount | grep "on $mntpoint " | grep -q /dev/md && umount -f $mntpoint
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+mdconfig -a -t swap -s 512m -u $mdstart || exit 1
+bsdlabel -w md$mdstart auto
+newfs $newfs_flags md${mdstart}$part > /dev/null
+mount /dev/md${mdstart}$part $mntpoint
+
+cp /usr/bin/true $mntpoint
+cd $mntpoint
+/tmp/advlock
+r=$?
+cd $odir
+
+while mount | grep "on $mntpoint " | grep -q /dev/md; do
+	umount $mntpoint || sleep 1
+done
+mdconfig -d -u $mdstart
+rm -f /tmp/advlock
+exit $r
+
+EOF
+#include <sys/param.h>
+#include <sys/mman.h>
+#include <sys/stat.h>
+#include <sys/wait.h>
+
+#include <machine/atomic.h>
+
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <signal.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <time.h>
+#include <unistd.h>
+
+volatile u_int *share;
+char *cmdline[] = { "./true", NULL };
+const char *tp;
+
+#define EXAMPLE 0
+#define PARALLEL 2
+
+#define RUNTIME (1 * 60)
+
+void
+handler(int i __unused) {
+
+        fprintf(stderr, "ALARM from %s.\n", tp);
+	_exit(1);
+}
+
+void
+slock(void)
+{
+	int fd;
+
+	setproctitle("%s", __func__);
+	atomic_add_int(&share[EXAMPLE], 1);
+	while (share[EXAMPLE] != PARALLEL)
+		;
+
+	tp = __func__;
+	alarm(2);
+	if ((fd = open(cmdline[0], O_RDONLY | O_SHLOCK)) == -1)
+		err(1, "open(%s). %d", cmdline[0], __LINE__);
+	usleep(500);
+	close(fd);
+
+	_exit(0);
+}
+
+void
+elock(void)
+{
+	int fd;
+
+	setproctitle("%s", __func__);
+	atomic_add_int(&share[EXAMPLE], 1);
+	while (share[EXAMPLE] != PARALLEL)
+		;
+
+	tp = __func__;
+	alarm(2);
+	if ((fd = open(cmdline[0], O_WRONLY | O_EXLOCK)) == -1) {
+		if (errno != ETXTBSY)
+			err(1, "open(%s). %d", cmdline[0], __LINE__);
+	} else {
+		usleep(500);
+		close(fd);
+	}
+
+	_exit(0);
+}
+
+void
+stest(void)
+{
+	int fd;
+
+	setproctitle("%s", __func__);
+	atomic_add_int(&share[EXAMPLE], 1);
+	while (share[EXAMPLE] != PARALLEL)
+		;
+
+	tp = __func__;
+	alarm(2);
+	if ((fd = open(cmdline[0], O_RDONLY | O_SHLOCK)) == -1)
+		err(1, "open(%s). %d", cmdline[0], __LINE__);
+
+	if (execve(cmdline[0], cmdline, NULL) == -1)
+		err(1, "execve(%s) @ %d", cmdline[0], __LINE__);
+
+	_exit(0);
+}
+
+void
+etest(void)
+{
+	int fd;
+
+	setproctitle("%s", __func__);
+	atomic_add_int(&share[EXAMPLE], 1);
+	while (share[EXAMPLE] != PARALLEL)
+		;
+
+	tp = __func__;
+	alarm(2);
+	if ((fd = open(cmdline[0], O_RDONLY | O_EXLOCK)) == -1)
+		err(1, "open(%s). %d", cmdline[0], __LINE__);
+
+	if (execve(cmdline[0], cmdline, NULL) == -1)
+		err(1, "execve(%s) @ %d", cmdline[0], __LINE__);
+
+	_exit(0);
+}
+
+int
+main(void)
+{
+	size_t len;
+	time_t start;
+	int i, n, r, s;
+
+	len = PAGE_SIZE;
+	if ((share = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_ANON | MAP_SHARED,
+	    -1, 0)) == MAP_FAILED)
+		err(1, "mmap");
+
+	signal(SIGALRM, handler);
+	n = r = 0;
+	start = time(NULL);
+	while ((time(NULL) - start) < RUNTIME) {
+		n++;
+		share[EXAMPLE] = 0;
+		if (fork() == 0)
+			slock();
+		if (fork() == 0)
+			stest();
+
+		for (i = 0; i < PARALLEL; i++) {
+			wait(&s);
+			r += s == 0 ? 0 : 1;
+		}
+		if (r != 0)
+			break;
+
+		share[EXAMPLE] = 0;
+		if (fork() == 0)
+			elock();
+		if (fork() == 0)
+			etest();
+
+		for (i = 0; i < PARALLEL; i++) {
+			wait(&s);
+			r += s == 0 ? 0 : 1;
+		}
+		if (r != 0)
+			break;
+	}
+	if (r != 0)
+		fprintf(stderr, "FAIL @ %d\n", n);
+
+	return (r);
+}

Added: user/pho/stress2/misc/dev2.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/dev2.sh	Sun Jan 17 12:07:57 2016	(r294211)
@@ -0,0 +1,144 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2016 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test parallel access to /dev. A non-root version.
+
+# "panic: Bad link elm 0xfffff8000b07ed00 prev->next != elm" seen.
+# https://people.freebsd.org/~pho/stress/log/dev2.txt
+
+# Fixed by r294204.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+here=`pwd`
+cd /tmp
+sed '1,/^EOF/d' < $here/$0 > dev2.c
+mycc -o dev2 -Wall -Wextra -O2 dev2.c || exit 1
+rm -f dev2.c
+
+kldstat -v | grep -q pty || kldload pty
+daemon sh -c \
+    "(cd $here/../testcases/swap; ./swap -t 6m -i 20 -k -l 100)" > \
+    /dev/null
+
+su $testuser -c /tmp/dev2
+
+while pkill -9 swap; do
+	:
+done
+
+rm -f /tmp/dev2
+exit
+EOF
+#include <sys/types.h>
+#include <sys/wait.h>
+
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <fts.h>
+#include <setjmp.h>
+#include <signal.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <time.h>
+#include <unistd.h>
+
+#define NFLAGS
+#define PARALLEL 4
+#define RUNTIME 300
+
+jmp_buf jbuf;
+char path[80];
+
+void
+handler(int i __unused) {
+        longjmp(jbuf, 1);
+}
+
+void
+churn(char *path)
+{
+	FTS *fts;
+	FTSENT *p;
+	time_t start;
+	int fd, ftsoptions;
+	char *args[2];
+
+	ftsoptions = FTS_PHYSICAL;
+	args[0] = path;
+	args[1] = 0;
+
+	start = time(NULL);
+	while (time(NULL) - start < RUNTIME) {
+		if ((fts = fts_open(args, ftsoptions, NULL)) == NULL)
+			err(1, "fts_open");
+
+		(void)setjmp(jbuf);
+		ualarm(0, 0);
+		while ((p = fts_read(fts)) != NULL) {
+			if (p->fts_info == FTS_D ||
+			   p->fts_info == FTS_DP)
+				continue;
+			ualarm(500000, 0);
+			if ((fd = open(p->fts_path, arc4random() % (O_CLOEXEC << 2))) == -1)
+				continue;
+			ualarm(0, 0);
+			usleep(arc4random() % 1000);
+			close(fd);
+
+		}
+
+		if (errno != 0 && errno != ENOENT)
+			warn("fts_read");
+		if (fts_close(fts) == -1)
+			err(1, "fts_close()");
+	}
+
+	_exit(0);
+}
+
+int
+main(void)
+{
+	int i;
+
+	signal(SIGALRM, handler);
+	for (i = 0; i < PARALLEL; i++)
+		if (fork() == 0)
+			churn("/dev");
+
+	for (i = 0; i < PARALLEL; i++)
+		wait(NULL);
+
+	return (0);
+}



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201601171207.u0HC7vgZ077840>